## mongo-c-driver 1.30.2

=== src/libbson/CMakeLists.txt ===

#  .d8888b.           888
# d88P  Y88b          888
# Y88b.               888
#  "Y888b.    .d88b.  888888 888  888 88888b.
#     "Y88b. d8P  Y8b 888    888  888 888 "88b
#       "888 88888888 888    888  888 888  888
# Y88b  d88P Y8b.     Y88b.  Y88b 888 888 d88P
#  "Y8888P"   "Y8888   "Y888  "Y88888 88888P"
#                                     888
#                                     888
#                                     888

cmake_minimum_required (VERSION 3.15)

project (libbson
   LANGUAGES C
   # Inherit the version from mongo-c-driver
   VERSION "${PROJECT_VERSION}"
   DESCRIPTION "The libbson BSON serialization library"
)

# These values are inherited from the mongo-c-driver parent. These are named as to
# match the CMake variables generated by project().
set(libbson_VERSION_PRERELEASE ${mongo-c-driver_VERSION_PRERELEASE})
set(libbson_VERSION_FULL ${mongo-c-driver_VERSION_FULL})

# Don't export symbols implicitly
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# A tag attached to libbson artifacts, denoting the *major* API version, used to
# potentially co-locate additional future major versions.
set (BSON_API_VERSION 1.0)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()


#  .d8888b.           888    888    d8b
# d88P  Y88b          888    888    Y8P
# Y88b.               888    888
#  "Y888b.    .d88b.  888888 888888 888 88888b.   .d88b.  .d8888b
#     "Y88b. d8P  Y8b 888    888    888 888 "88b d88P"88b 88K
#       "888 88888888 888    888    888 888  888 888  888 "Y8888b.
# Y88b  d88P Y8b.     Y88b.  Y88b.  888 888  888 Y88b 888      X88
#  "Y8888P"   "Y8888   "Y888  "Y888 888 888  888  "Y88888  88888P'
#                                                     888
#                                                Y8b d88P
#                                                 "Y88P"

# libbson-specific configuration settings. Note that we inherit all settings
# from the parent!

mongo_setting(
   BSON_OUTPUT_BASENAME "Set the output basename for the libbson library"
   TYPE STRING
   DEFAULT VALUE "bson"
)
# Control over what components are installed:
mongo_bool_setting(
   ENABLE_STATIC_LIBBSON_INSTALL "Install static libbson"
   VISIBLE_IF ENABLE_STATIC)
mongo_bool_setting(
   ENABLE_SHARED_LIBBSON_INSTALL "Install shared libbson"
   VISIBLE_IF ENABLE_SHARED)


#  .d8888b.  888                        888
# d88P  Y88b 888                        888
# 888    888 888                        888
# 888        88888b.   .d88b.   .d8888b 888  888 .d8888b
# 888        888 "88b d8P  Y8b d88P"    888 .88P 88K
# 888    888 888  888 88888888 888      888888K  "Y8888b.
# Y88b  d88P 888  888 Y8b.     Y88b.    888 "88b      X88
#  "Y8888P"  888  888  "Y8888   "Y8888P 888  888  88888P'

# Configure-time platform checks. These start as regular CMake booleans, but are
# converted to 0/1 values (with mongo_bool01) so that they can be inserted into
# bson-config.h as preprocessor values. We cannot use #cmakedefine01, as we need
# to keep compatibility with an external Autotools-generated library configuration

include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckStructHasMember)
include (CheckSymbolExists)
include (TestBigEndian)
include (InstallRequiredSystemLibraries)
include (CheckIncludeFiles)

# See https://public.kitware.com/Bug/view.php?id=15659
check_symbol_exists (snprintf stdio.h BSON_HAVE_SNPRINTF)
mongo_bool01 (BSON_HAVE_SNPRINTF BSON_HAVE_SNPRINTF)
check_struct_has_member ("struct timespec" tv_sec time.h BSON_HAVE_TIMESPEC)
mongo_bool01 (BSON_HAVE_TIMESPEC BSON_HAVE_TIMESPEC)
check_symbol_exists (gmtime_r time.h BSON_HAVE_GMTIME_R)
mongo_bool01 (BSON_HAVE_GMTIME_R BSON_HAVE_GMTIME_R)
check_function_exists (rand_r BSON_HAVE_RAND_R)
mongo_bool01 (BSON_HAVE_RAND_R BSON_HAVE_RAND_R)
check_include_file (strings.h BSON_HAVE_STRINGS_H)
mongo_bool01 (BSON_HAVE_STRINGS_H BSON_HAVE_STRINGS_H)
check_symbol_exists (strlcpy string.h BSON_HAVE_STRLCPY)
mongo_bool01 (BSON_HAVE_STRLCPY BSON_HAVE_STRLCPY)
check_include_file (stdbool.h BSON_HAVE_STDBOOL_H)
mongo_bool01 (BSON_HAVE_STDBOOL_H BSON_HAVE_STDBOOL_H)
check_symbol_exists (clock_gettime time.h BSON_HAVE_CLOCK_GETTIME)
mongo_bool01 (BSON_HAVE_CLOCK_GETTIME BSON_HAVE_CLOCK_GETTIME)
check_symbol_exists (strnlen string.h BSON_HAVE_STRNLEN)
mongo_bool01 (BSON_HAVE_STRNLEN BSON_HAVE_STRNLEN)
check_symbol_exists (aligned_alloc stdlib.h BSON_HAVE_ALIGNED_ALLOC)
mongo_bool01 (BSON_HAVE_ALIGNED_ALLOC BSON_HAVE_ALIGNED_ALLOC)
test_big_endian (BSON_BIG_ENDIAN)

if (WIN32)
   set (BSON_OS 2)
else ()
   set (BSON_OS 1)
endif ()

if (BSON_BIG_ENDIAN)
   set (BSON_BYTE_ORDER 4321)
else ()
   set (BSON_BYTE_ORDER 1234)
endif ()

configure_file (
   "${PROJECT_SOURCE_DIR}/src/bson/bson-config.h.in"
   "${PROJECT_BINARY_DIR}/src/bson/bson-config.h"
)

configure_file (
   "${PROJECT_SOURCE_DIR}/src/bson/bson-version.h.in"
   "${PROJECT_BINARY_DIR}/src/bson/bson-version.h"
)

if (ENABLE_APPLE_FRAMEWORK)
   configure_file (
      "${PROJECT_SOURCE_DIR}/src/bson/modules/module.modulemap.in"
      "${PROJECT_BINARY_DIR}/src/bson/modules/module.modulemap"
   )
endif ()

# 8888888b.            .d888 d8b          d8b 888    d8b
# 888  "Y88b          d88P"  Y8P          Y8P 888    Y8P
# 888    888          888                     888
# 888    888  .d88b.  888888 888 88888b.  888 888888 888  .d88b.  88888b.  .d8888b
# 888    888 d8P  Y8b 888    888 888 "88b 888 888    888 d88""88b 888 "88b 88K
# 888    888 88888888 888    888 888  888 888 888    888 888  888 888  888 "Y8888b.
# 888  .d88P Y8b.     888    888 888  888 888 Y88b.  888 Y88..88P 888  888      X88
# 8888888P"   "Y8888  888    888 888  888 888  "Y888 888  "Y88P"  888  888  88888P'

# Base INTERFACE library propagates in-build-tree requirements for using libbson
add_library(_libbson_build_interface INTERFACE)
# Header directories required for libbson in-source
target_include_directories(_libbson_build_interface INTERFACE
   # The default src/
   src/
   # The generated src/
   ${PROJECT_BINARY_DIR}/src/
   # The source directories of the common lib:
   ${mongo-c-driver_SOURCE_DIR}/src/common/src/
   # Generated:
   ${mongo-c-driver_BINARY_DIR}/src/common/src/
   )
target_link_libraries(_libbson_build_interface INTERFACE mongo::detail::c_platform)

# Collect all source files
file(GLOB_RECURSE all_sources CONFIGURE_DEPENDS
   src/*.c src/*.h
   # Include common library source files within libbson itself (names
   # will be mangled with MCOMMON_NAME_PREFIX)
   "${mongo-c-driver_SOURCE_DIR}/src/common/src/*.c"
   )

# List of the primary BSON library targets that we are building
set(bson_libs)

if(ENABLE_STATIC)
   add_library(bson_static STATIC ${all_sources})
   list(APPEND bson_libs bson_static)
   # Define `BSON_STATIC` when building to suppress the annotation __declspec(dllexport).
   # This prevents consumers of bson_static from exporting the symbols.
   target_compile_definitions(bson_static PRIVATE BSON_STATIC)
   # When consumers link against bson_static, suppress the annotation __declspec(dllimport),
   # since those symbols will be available immediately at the link step:
   target_compile_definitions(bson_static INTERFACE BSON_STATIC)

   if(ENABLE_PIC)
      # User wants static libs to use PIC code.
      set_property(TARGET bson_static PROPERTY POSITION_INDEPENDENT_CODE TRUE)
   endif()
endif()

if(ENABLE_SHARED)
   add_library(bson_shared SHARED  ${all_sources})
   if(WIN32)
      # Add resource-definition script for Windows shared library (.dll).
      configure_file(libbson.rc.in libbson.rc)
      target_sources(bson_shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/libbson.rc)
   endif()
   list(APPEND bson_libs bson_shared)
endif()

if(NOT bson_libs)
   message(FATAL_ERROR "Neither bson_shared nor bson_static is going to be built. Did you mean to enable at least one of them?")
endif()

# Set target properties for the libraries.
mongo_target_requirements(
   ${bson_libs}
   LINK_LIBRARIES
      PUBLIC
         # Build-local requirements:
         $<BUILD_INTERFACE:_libbson_build_interface>
         # Include in the install interface explicitly:
         mongo::detail::c_platform
   COMPILE_DEFINITIONS
      PRIVATE
         # Tell headers that they are part of compilation:
         BSON_COMPILATION
         # Enable NaN parsing in jsonsl
         JSONSL_PARSE_NAN
         # Set the name mangling scheme for the common libraries
         MCOMMON_NAME_PREFIX=_bson_mcommon
   COMPILE_OPTIONS
      PRIVATE
         # Enable unconditional warnings-as-errors for our source code.
         ${mongoc-warning-options}

         # Macro constant INFINITY triggers constant arithmetic overflow warnings in
         # VS 2013, but VS 2013 doesn't support inline warning suppression.
         # Remove once support for VS 2013 is dropped.
         $<$<AND:$<C_COMPILER_ID:MSVC>,$<VERSION_LESS:${MSVC_VERSION},1900>>:/wd4756>
)

set_target_properties(${bson_libs} PROPERTIES
   VERSION "0.0.0"
   SOVERSION "0"
   OUTPUT_NAME "${BSON_OUTPUT_BASENAME}-${BSON_API_VERSION}"
)
if(TARGET bson_static)
   set_property(TARGET bson_static PROPERTY OUTPUT_NAME "${BSON_OUTPUT_BASENAME}-static-${BSON_API_VERSION}")
endif()

if (ENABLE_APPLE_FRAMEWORK)
   set_target_properties(bson_shared PROPERTIES
      FRAMEWORK TRUE
      MACOSX_FRAMEWORK_BUNDLE_VERSION ${MONGOC_VERSION}
      MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${MONGOC_VERSION}
      MACOSX_FRAMEWORK_IDENTIFIER org.mongodb.bson
      OUTPUT_NAME "${BSON_OUTPUT_BASENAME}"
      PUBLIC_HEADER "${HEADERS}"
   )
endif ()


# 8888888888                                          888
# 888                                                 888
# 888                                                 888
# 8888888    888  888  8888b.  88888b.d88b.  88888b.  888  .d88b.  .d8888b
# 888        `Y8bd8P'     "88b 888 "888 "88b 888 "88b 888 d8P  Y8b 88K
# 888          X88K   .d888888 888  888  888 888  888 888 88888888 "Y8888b.
# 888        .d8""8b. 888  888 888  888  888 888 d88P 888 Y8b.          X88
# 8888888888 888  888 "Y888888 888  888  888 88888P"  888  "Y8888   88888P'
#                                            888
#                                            888
#                                            888

if (ENABLE_EXAMPLES)
   function (add_example bin src)
      add_executable (${bin} EXCLUDE_FROM_ALL ${src})
      add_dependencies (mongo_c_driver_examples ${bin})

      # Enable unconditional warnings-as-errors for our source code.
      target_compile_options (${bin} PRIVATE ${mongoc-warning-options})

      # Link against the shared lib like normal apps
      if(TARGET bson_shared)
         target_link_libraries (${bin} bson_shared)
      elseif(TARGET bson_static)
         target_link_libraries (${bin} bson_static)
      else()
         return()
      endif()
   endfunction ()

   add_example (bcon-col-view examples/bcon-col-view.c)
   add_example (bcon-speed examples/bcon-speed.c)
   add_example (bson-metrics examples/bson-metrics.c)
   if (NOT WIN32)
      target_link_libraries (bson-metrics m)
      add_example (bson-streaming-reader examples/bson-streaming-reader.c)
   endif ()
   add_example (bson-to-json examples/bson-to-json.c)
   add_example (bson-validate examples/bson-validate.c)
   add_example (json-to-bson examples/json-to-bson.c)
   add_example (bson-check-depth examples/bson-check-depth.c)
   add_example (creating examples/creating.c)
   add_example (extended-json examples/extended-json.c)
endif () # ENABLE_EXAMPLES


# 8888888                   888             888 888
#   888                     888             888 888
#   888                     888             888 888
#   888   88888b.  .d8888b  888888  8888b.  888 888
#   888   888 "88b 88K      888        "88b 888 888
#   888   888  888 "Y8888b. 888    .d888888 888 888
#   888   888  888      X88 Y88b.  888  888 888 888
# 8888888 888  888  88888P'  "Y888 "Y888888 888 888

set (BSON_HEADER_INSTALL_DIR

=== src/libmongoc/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

project (libmongoc
   LANGUAGES C
   # Inherit the version from mongo-c-driver
   VERSION "${PROJECT_VERSION}"
   DESCRIPTION "The MongoDB C Database Driver library"
)

# These values are inherited from the mongo-c-driver parent. These are named as to
# match the CMake variables generated by project().
set(libmongoc_VERSION_PRERELEASE ${mongo-c-driver_VERSION_PRERELEASE})
set(libmongoc_VERSION_FULL ${mongo-c-driver_VERSION_FULL})

set (MONGOC_API_VERSION 1.0)

include (CheckSchedGetCPU)
include (CheckStructHasMember)
include (CheckSymbolExists)
include (CheckTypeSize)
include (CMakePushCheckState)
include (InstallRequiredSystemLibraries)

message (STATUS "libmongoc version (from VERSION_CURRENT file): ${MONGOC_VERSION}")

set (MONGOC_API_VERSION 1.0)
set (MONGOC_TARGETS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/mongoc-${MONGOC_API_VERSION}")

# Defaults.
set (MONGOC_ENABLE_COMPRESSION 0)
set (MONGOC_ENABLE_COMPRESSION_SNAPPY 0)
set (MONGOC_ENABLE_COMPRESSION_ZLIB 0)
set (MONGOC_ENABLE_COMPRESSION_ZSTD 0)

# Definition for mongoc-config.h:
mongo_pick(MONGOC_ENABLE_SRV 1 0 ENABLE_SRV)

set (MONGOC_OUTPUT_BASENAME "mongoc" CACHE STRING "Output mongoc library base name")

if (NOT ENABLE_ZLIB MATCHES "SYSTEM|AUTO|BUNDLED|OFF")
   message (FATAL_ERROR
      "ENABLE_ZLIB option must be SYSTEM, BUNDLED, AUTO, or OFF"
      )
endif ()

if (NOT ENABLE_ZSTD MATCHES "ON|AUTO|OFF")
   message (FATAL_ERROR "ENABLE_ZSTD option must be ON, AUTO, or OFF")
endif ()

set (ZLIB_INCLUDE_DIRS "")
if (ENABLE_ZLIB MATCHES "SYSTEM|AUTO")
   message (STATUS "Searching for zlib CMake packages")
   include (FindZLIB)
   if (ZLIB_FOUND)
      message (STATUS "   zlib found version \"${ZLIB_VERSION_STRING}\"")
      message (STATUS "   zlib include path \"${ZLIB_INCLUDE_DIRS}\"")
      message (STATUS "   zlib libraries \"${ZLIB_LIBRARIES}\"")
   else ()
      if (ENABLE_ZLIB STREQUAL "SYSTEM")
         message (FATAL_ERROR
            "Unable to find system zlib package. Either specify the zlib \
            location by setting ZLIB_ROOT, or else set ENABLE_ZLIB=BUNDLED or \
            set ENABLE_ZLIB=OFF."
            )
      endif ()
      set (ZLIB_LIBRARIES "")
   endif ()
endif ()

if ( (ENABLE_ZLIB STREQUAL "BUNDLED")
   OR (ENABLE_ZLIB STREQUAL "AUTO" AND NOT ZLIB_FOUND) )
   message (STATUS "Enabling zlib compression (bundled)")
   add_library (zlib_obj OBJECT
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/adler32.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/crc32.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/deflate.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/infback.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inffast.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inflate.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/inftrees.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/trees.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/zutil.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/compress.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/uncompr.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzclose.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzlib.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzread.c
      ${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1/gzwrite.c
   )
   set_property (TARGET zlib_obj PROPERTY POSITION_INDEPENDENT_CODE TRUE)
   # This tells the bundled zlib where to find its generated headers
   target_include_directories (zlib_obj
      BEFORE PUBLIC
      "${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1"
      "${CMAKE_BINARY_DIR}/src/zlib-1.3.1"
   )
   # Disable all warnings for compiling Zlib
   target_compile_options (zlib_obj PRIVATE -w)
   set (SOURCES ${SOURCES} $<TARGET_OBJECTS:zlib_obj>)
   # This tells mongoc_shared/mongoc_static where to find generated zlib headers
   set (
      ZLIB_INCLUDE_DIRS
      "${mongo-c-driver_SOURCE_DIR}/src/zlib-1.3.1"
      "${CMAKE_BINARY_DIR}/src/zlib-1.3.1"
   )
endif ()

if (NOT ENABLE_ZLIB STREQUAL "OFF")
   # At this point the system zlib was found, or the bundled library was used
   include (CheckIncludeFiles)
   check_include_files ("unistd.h" HAVE_UNISTD_H)
   check_include_files ("stdarg.h" HAVE_STDARG_H)
   if (HAVE_UNISTD_H)
      add_definitions (-DHAVE_UNISTD_H)
      list (APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_UNISTD_H)
   endif ()
   if (HAVE_STDARG_H)
      add_definitions (-DHAVE_STDARG_H)
      list (APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDARG_H)
   endif ()
   set (MONGOC_ENABLE_COMPRESSION 1)
   set (MONGOC_ENABLE_COMPRESSION_ZLIB 1)
else ()
   message (STATUS "Disabling zlib compression")
endif ()

if (NOT ENABLE_ZSTD STREQUAL OFF)
   message (STATUS "Searching for compression library zstd")
   find_package(PkgConfig)
   pkg_check_modules (ZSTD libzstd)

   if (NOT ZSTD_FOUND)
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "  Not found")
      else ()
         message (STATUS "  Not found")
      endif ()
   # The compression format below this version isn't supported. See SERVER-43070
   elseif (${ZSTD_VERSION} VERSION_LESS "0.8.0")
      if (ENABLE_ZSTD MATCHES "ON")
         message (FATAL_ERROR "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      else ()
         message (STATUS "Detected zstd version ${ZSTD_VERSION} but version 0.8.0 required")
      endif ()
   else ()
      message (STATUS "  Found zstd version ${ZSTD_VERSION} in ${ZSTD_INCLUDE_DIRS}")
      set (MONGOC_ENABLE_COMPRESSION 1)
      set (MONGOC_ENABLE_COMPRESSION_ZSTD 1)

      include_directories (${ZSTD_INCLUDE_DIRS})
      link_directories (${ZSTD_LIBRARY_DIRS})
      set (MONGOC_ZSTD_LIBRARIES ${ZSTD_LINK_LIBRARIES})
   endif()
endif()

add_library(_mongoc-dependencies INTERFACE)
add_library(mongo::detail::c_dependencies ALIAS _mongoc-dependencies)
target_link_libraries(_mongoc-dependencies INTERFACE mongo::detail::c_platform)
target_link_libraries(_mongoc-dependencies INTERFACE mongo::detail::c_platform $<$<PLATFORM_ID:Windows>:advapi32.lib>)
install(TARGETS _mongoc-dependencies EXPORT mongoc-targets)
set_property(TARGET _mongoc-dependencies PROPERTY EXPORT_NAME detail::c_dependencies)

# d888888b db      .d8888.
# `~~88~~' 88      88'  YP
#    88    88      `8bo.
#    88    88        `Y8b.
#    88    88booo. db   8D
#    YP    Y88888P `8888Y'

# Pick the TLS library to use.
function(_pick_which_tls_lib ssl_opt)
   # Initial value, if not later set:
   set_property(DIRECTORY PROPERTY _mongoc-tls-backend OFF)
   if(ssl_opt STREQUAL "AUTO")
      # Try to pick one automatically
      _auto_pick_tls_lib()
   elseif(ssl_opt)
      # The user named a TLS library specifically. Use that one:
      _use_named_tls_lib("${ssl_opt}")
   else()
      # User has disabled TLS selection
   endif()
endfunction()

# Attempt to automatically find and use a TLS library for the current platform
function(_auto_pick_tls_lib)
   if(WIN32)
      # Windows has SecureChannel
      _use_named_tls_lib(WINDOWS)
   elseif(APPLE)
      # Apple has SecureTransport
      _use_named_tls_lib(DARWIN)
   else()
      # Try to find one of the common open-source TLS libraries
      find_package(OpenSSL)
      if(OpenSSL_FOUND)
         _use_named_tls_lib(OPENSSL)
      else()
         # No OpenSSL. What about LibreSSL?
         find_package(LibreSSL)
         if(LibreSSL_FOUND)
            message(DEPRECATION "LibreSSL was automatically chosen as the TLS library. Support for LibreSSL is deprecated and may be removed in a future major release. Use ENABLE_SSL option to specify a different TLS library.")
            _use_named_tls_lib(LIBRESSL)
         endif()
      endif()
   endif()
endfunction()

# Per-backend link libs/options:
set(SecureTransport/LINK_LIBRARIES "-framework CoreFoundation" "-framework Security")
set(SecureTransport/pkg_config_LIBS -framework Corefoundation -framework Security)
set(SecureChannel/LINK_LIBRARIES secur32.lib crypt32.lib Bcrypt.lib)
set(SecureChannel/pkg_config_LIBS ${SecureChannel/LINK_LIBRARIES})
set(LibreSSL/LINK_LIBRARIES LibreSSL::TLS LibreSSL::Crypto)
set(LibreSSL/pkg_config_LIBS -ltls -lcrypto)
set(OpenSSL/LINK_LIBRARIES OpenSSL::SSL OpenSSL::Crypto $<$<PLATFORM_ID:Windows>:crypt32.lib>)
set(OpenSSL/pkg_config_LIBS -lssl -lcrypto $<$<PLATFORM_ID:Windows>:crypt32.lib>)
# Use *exactly* the TLS library identified by the given name, which is one of
#  `OPENSSL`, `LIBRESSL`, `DARWIN`, or `WINDOWS`.
function(_use_named_tls_lib libname)
   # Use this property to track what package we import for our TLS libraries:
   set_property(DIRECTORY PROPERTY _mongoc-tls-package NO)
   if(libname STREQUAL "OPENSSL")
      find_package(OpenSSL REQUIRED)
      set(backend OpenSSL)
      set_property(DIRECTORY PROPERTY _mongoc-tls-package OpenSSL)
   elseif(libname STREQUAL "LIBRESSL")
      find_package(LibreSSL REQUIRED)
      set(backend LibreSSL)
      install(
         FILES "${mongo-c-driver_SOURCE_DIR}/build/cmake/FindLibreSSL.cmake"
         DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/mongoc-${MONGOC_API_VERSION}/3rdParty"
         )
      set_property(DIRECTORY PROPERTY _mongoc-tls-package LibreSSL)
   elseif(libname STREQUAL "DARWIN")
      set(backend SecureTransport)
   elseif(libname STREQUAL "WINDOWS")
      set(backend SecureChannel)
   else()
      message(FATAL_ERROR "Unknown TLS library requested: “${libname}”")
   endif()
   add_library(_mongoc-tls_backend INTERFACE)
   install(TARGETS _mongoc-tls_backend EXPORT mongoc-targets)
   target_link_libraries(_mongoc-dependencies INTERFACE _mongoc-tls_backend)
   set_property(TARGET _mongoc-tls_backend PROPERTY EXPORT_NAME detail::c_tls_backend)
   target_link_libraries(_mongoc-tls_backend INTERFACE ${${backend}/LINK_LIBRARIES})
   target_link_options(_mongoc-tls_backend INTERFACE ${${backend}/LINK_OPTIONS})
   set_property(DIRECTORY PROPERTY _mongoc-tls-backend "${backend}")
endfunction()

_pick_which_tls_lib("${ENABLE_SSL}")
# This property will be set by _pick_which_tls_lib:
get_directory_property(TLS_BACKEND _mongoc-tls-backend)
message(STATUS "libmongoc TLS : ${TLS_BACKEND}")
# Used by *-config.cmake to do a find_dependency():
get_directory_property(TLS_IMPORT_PACKAGE _mongoc-tls-package)
set_package_properties(
   OpenSSL PROPERTIES
   DESCRIPTION "the standard open-source implementation of TLS, X509, and more"
   TYPE OPTIONAL
   PURPOSE "Provides a cryptography and TLS backend"
)
set_package_properties(
   LibreSSL PROPERTIES
   DESCRIPTION "an alternative implementation of the OpenSSL interface, created by the OpenBSD project"
   TYPE OPTIONAL
   PURPOSE "Provides a cryptography and TLS backend"
)

mongo_bool01(MONGOC_ENABLE_SSL [[TLS_BACKEND]])
mongo_bool01(MONGOC_ENABLE_SSL_SECURE_CHANNEL [[TLS_BACKEND STREQUAL "SecureChannel"]])
mongo_bool01(MONGOC_ENABLE_SSL_SECURE_TRANSPORT [[TLS_BACKEND STREQUAL "SecureTransport"]])
mongo_bool01(MONGOC_ENABLE_SSL_OPENSSL [[TLS_BACKEND STREQUAL "OpenSSL"]])
mongo_bool01(MONGOC_ENABLE_SSL_LIBRESSL [[TLS_BACKEND STREQUAL "LibreSSL"]])

mongo_bool01(MONGOC_ENABLE_CRYPTO [[TLS_BACKEND]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_LIBCRYPTO [[MONGOC_ENABLE_SSL_OPENSSL OR MONGOC_ENABLE_SSL_LIBRESSL]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_CNG [[MONGOC_ENABLE_SSL_SECURE_CHANNEL]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_COMMON_CRYPTO [[MONGOC_ENABLE_SSL_SECURE_TRANSPORT]])
mongo_bool01(MONGOC_ENABLE_CRYPTO_SYSTEM_PROFILE [[ENABLE_CRYPTO_SYSTEM_PROFILE]])
add_feature_info("TLS" "${MONGOC_ENABLE_SSL}" "for secure network communication (${TLS_BACKEND})")
add_feature_info("Cryptography" "${MONGOC_ENABLE_CRYPTO}" "cryptographic primitives (${TLS_BACKEND})")

include(CMakePushCheckState)
include(CheckSymbolExists)
if(TLS_BACKEND STREQUAL "OpenSSL")
   # Check for newer OpenSSL string functions
   cmake_push_check_state()
   list(APPEND CMAKE_REQUIRED_LIBRARIES OpenSSL::SSL OpenSSL::Crypto)
   check_symbol_exists(
      ASN1_STRING_get0_data
      "openssl/asn1.h"
      HAVE_ASN1_STRING_GET0_DATA
   )

=== src/libbson/fuzz/CMakeLists.txt ===
add_library(fuzz-properties INTERFACE)
target_link_libraries(fuzz-properties INTERFACE bson_static)
set_property(TARGET fuzz-properties APPEND PROPERTY INTERFACE_LINK_OPTIONS -fsanitize=fuzzer)

add_executable(fuzz-init-from-json EXCLUDE_FROM_ALL init-from-json.c)
target_link_libraries(fuzz-init-from-json PRIVATE fuzz-properties)

if(CMAKE_CXX_COMPILER)
    add_executable(fuzz-validate EXCLUDE_FROM_ALL validate.cpp)
    target_link_libraries(fuzz-validate PRIVATE fuzz-properties)
    add_executable(validate-repro EXCLUDE_FROM_ALL validate-repro.cpp)
    target_link_libraries(validate-repro PRIVATE bson_static)
endif()

add_executable(fuzz-bson-utf8-escape-for-json EXCLUDE_FROM_ALL utf8-escape-for-json.c)
target_link_libraries(fuzz-bson-utf8-escape-for-json PRIVATE fuzz-properties)

=== src/libbson/examples/cmake-deprecated/find_package/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libbson.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_bson LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libbson.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (libbson-1.0 1.7 REQUIRED)

message (STATUS "   libbson found version \"${BSON_VERSION}\"")
message (STATUS "   libbson include path \"${BSON_INCLUDE_DIRS}\"")
message (STATUS "   libbson libraries \"${BSON_LIBRARIES}\"")

# The "hello_bson.c" sample program is shared among four tests.
add_executable (hello_bson ../../hello_bson.c)
target_include_directories (hello_bson PRIVATE ${BSON_INCLUDE_DIRS})
target_link_libraries (hello_bson PRIVATE ${BSON_LIBRARIES})
target_compile_definitions (hello_bson PRIVATE ${BSON_DEFINITIONS})

=== src/libbson/examples/cmake-deprecated/find_package_static/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libbson.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_bson LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libbson.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (libbson-static-1.0 1.7 REQUIRED)

message (STATUS "   libbson-static found version \"${BSON_STATIC_VERSION}\"")
message (STATUS "   libbson-static include path \"${BSON_STATIC_INCLUDE_DIRS}\"")
message (STATUS "   libbson-static libraries \"${BSON_STATIC_LIBRARIES}\"")

# The "hello_bson.c" sample program is shared among four tests.
add_executable (hello_bson ../../hello_bson.c)
target_include_directories (hello_bson PRIVATE ${BSON_STATIC_INCLUDE_DIRS})
target_link_libraries (hello_bson PRIVATE ${BSON_STATIC_LIBRARIES})
target_compile_definitions (hello_bson PRIVATE ${BSON_STATIC_DEFINITIONS})

=== src/libbson/examples/cmake/find_package/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libbson.

cmake_minimum_required (VERSION 3.0)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_bson LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libbson.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (bson-1.0 1.7 REQUIRED)

# The "hello_bson.c" sample program is shared among four tests.
add_executable (hello_bson ../../hello_bson.c)
target_link_libraries (hello_bson PRIVATE mongo::bson_shared)

=== src/libbson/examples/cmake/find_package_static/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libbson.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_bson LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libbson.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (bson-1.0 1.7 REQUIRED)

# The "hello_bson.c" sample program is shared among four tests.
add_executable (hello_bson ../../hello_bson.c)
target_link_libraries (hello_bson PRIVATE mongo::bson_static)

=== src/libmongoc/examples/cmake-deprecated/find_package/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libmongoc.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_mongoc LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libmongoc.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (libmongoc-1.0 1.7 REQUIRED)

message (STATUS "   mongoc found version \"${MONGOC_VERSION}\"")
message (STATUS "   mongoc include path \"${MONGOC_INCLUDE_DIRS}\"")
message (STATUS "   mongoc libraries \"${MONGOC_LIBRARIES}\"")

# The "hello_mongoc.c" sample program is shared among four tests.
add_executable (hello_mongoc ../../hello_mongoc.c)
target_include_directories (hello_mongoc PRIVATE "${MONGOC_INCLUDE_DIRS}")
target_link_libraries (hello_mongoc PRIVATE "${MONGOC_LIBRARIES}")
target_compile_definitions (hello_mongoc PRIVATE "${MONGOC_DEFINITIONS}")

=== src/libmongoc/examples/cmake-deprecated/find_package_static/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libmongoc.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_mongoc LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libmongoc.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (libmongoc-static-1.0 1.7 REQUIRED)

message (STATUS "   mongoc found version \"${MONGOC_STATIC_VERSION}\"")
message (STATUS "   mongoc include path \"${MONGOC_STATIC_INCLUDE_DIRS}\"")
message (STATUS "   mongoc libraries \"${MONGOC_STATIC_LIBRARIES}\"")

# The "hello_mongoc.c" sample program is shared among four tests.
add_executable (hello_mongoc ../../hello_mongoc.c)
target_include_directories (hello_mongoc PRIVATE "${MONGOC_STATIC_INCLUDE_DIRS}")
target_link_libraries (hello_mongoc PRIVATE "${MONGOC_STATIC_LIBRARIES}")
target_compile_definitions (hello_mongoc PRIVATE "${MONGOC_STATIC_DEFINITIONS}")

=== src/libmongoc/examples/cmake/find_package/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libmongoc.

cmake_minimum_required (VERSION 3.0)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_mongoc LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libmongoc.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (mongoc-1.0 1.7 REQUIRED)

# The "hello_mongoc.c" sample program is shared among four tests.
add_executable (hello_mongoc ../../hello_mongoc.c)
target_link_libraries (hello_mongoc PRIVATE mongo::mongoc_shared)

=== src/libmongoc/examples/cmake/find_package_static/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libmongoc.

cmake_minimum_required (VERSION 3.0)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_mongoc LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libmongoc.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (mongoc-1.0 1.7 REQUIRED)

# The "hello_mongoc.c" sample program is shared among four tests.
add_executable (hello_mongoc ../../hello_mongoc.c)
target_link_libraries (hello_mongoc PRIVATE mongo::mongoc_static)

=== src/libmongoc/examples/cmake/vcpkg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(vcpkg-example-project)

find_package(mongoc-1.0 CONFIG REQUIRED)
message(STATUS "Found libmongoc: ${mongoc-1.0_DIR}")

enable_testing()

add_executable(my-app app.c)
target_link_libraries(my-app PRIVATE mongo::mongoc_static)
add_test(my-app my-app)
set_property(
    TEST my-app
    PROPERTY PASS_REGULAR_EXPRESSION
    "^Linked with libmongoc [1-9]+\\.[0-9]+\\.[0-9]+\r?\n$"
)

=== debian/changelog ===
mongo-c-driver (1.30.2-1) unstable; urgency=medium

  * New upstream release
  * Update to Standards-Version 4.7.2 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 05 Mar 2025 18:00:57 -0500

=== debian/control ===
Source: mongo-c-driver
Priority: optional
Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11),
               cmake,
               libssl-dev,
               pkgconf,
               python3-sphinx,
               python3-sphinx-design,
               furo,
               libmongocrypt-dev (>= 1.12.0) <!pkg.mongo-c-driver.no-libmongocrypt>,
               zlib1g-dev,
               libsasl2-dev,
               libsnappy-dev,
               libutf8proc-dev,
               libzstd-dev
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/mongodb/mongo-c-driver
Vcs-Git: https://github.com/mongodb/mongo-c-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-c-driver/tree/master

Package: libmongoc-dev
Section: libdevel
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libmongoc-1.0-0t64 (= ${binary:Version}),
         libbson-dev (= ${binary:Version}),
         libmongocrypt-dev (>= 1.12.0),
         libssl-dev,
         zlib1g-dev,
         libsnappy-dev,
         libsasl2-dev,
         libutf8proc-dev,
         libzstd-dev,
         ${misc:Depends}
Description: MongoDB C client library - dev files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongoc.

Package: libmongoc-1.0-0t64
Provides: ${t64:Provides}
Replaces: libmongoc-1.0-0
Breaks: libmongoc-1.0-0 (<< ${source:Version})
Architecture: any
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C client library - runtime files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the libmongoc runtime libraries, for applications that
 have been built with libmongoc.

Package: libmongoc-doc
Section: doc
Architecture: all
Build-Profiles: <!pkg.mongo-c-driver.no-libmongocrypt>
Depends: libjs-mathjax,
         ${misc:Depends}
Description: MongoDB C client library - documentation
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the man pages for libmongoc.

Package: libbson-dev
Section: libdevel
Architecture: any
Depends: libbson-1.0-0t64 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbson.

Package: libbson-1.0-0t64
Provides: ${t64:Provides}
Replaces: libbson-1.0-0
Breaks: libbson-1.0-0 (<< ${source:Version})
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbson runtime libraries, for applications that
 have been built with libbson.

Package: libbson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to parse and generate BSON documents - documentation
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the man pages for libbson.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND := -lpthread
# Link with libatomic on riscv64 to get access to the __atomic_*_1 functions
ifeq ($(DEB_HOST_ARCH),riscv64)
	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	DOCS=OFF
else
	DOCS=ON
endif

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_configure:
	[ "$(DOCS)" = "ON" ] || echo "Found 'nodoc' in 'DEB_BUILD_OPTIONS'; not building documentation"
	echo $(DEB_VERSION_UPSTREAM) > VERSION_CURRENT
	dh_auto_configure -- \
	-DENABLE_AUTOMATIC_INIT_AND_CLEANUP=OFF \
	-DENABLE_MONGOC=ON \
	-DENABLE_MAN_PAGES=$(DOCS) \
	-DENABLE_HTML_DOCS=$(DOCS) \
	-DENABLE_MAINTAINER_FLAGS=ON \
	-DENABLE_TESTS=OFF \
	-DENABLE_ZLIB=SYSTEM \
	-DUSE_BUNDLED_UTF8PROC=OFF

override_dh_auto_clean:
	rm -f VERSION_CURRENT
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp/usr/include -type f -name "*.h" -print0 | \
		xargs -0r sed -i -e 's@\([" ]\)[^ ]*-f\(file\|debug\)-prefix-map=[^ ]*\([" ]\)@\1\3@g'

#override_dh_install:
#	dh_install -a -X.la -Xmongoc-stat -Xdoc/mongo-c-driver -Xdoc/libbson -Xman/man3 -X-priv.so -X-priv.pc --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_test:
	echo "Skip dh_auto_test because upstream CI already tests extensively"

## mongo-c-driver 1.30.3

=== debian/changelog ===
mongo-c-driver (1.30.3-1) unstable; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 14 Apr 2025 13:21:52 -0400
